using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using IE = Interop.SHDocVw;
using AddinExpress.IE;
 
namespace CustomContextMenu
{
    /// <summary>
    /// Add-in Express for Internet Explorer Module
    /// </summary>
    [ComVisible(true), Guid("CE927E4E-FD1C-4A48-B3F0-0169CF66B19F")]
    public class IEModule : AddinExpress.IE.ADXIEModule
    {
        private IOleCommandTarget targetObj = null;
        private mshtml.IHTMLElement targetElem = null;
        private const uint OLECMDEXECOPT_DODEFAULT = 0;
        private const uint OLECMDID_PROPERTIES = 10;

        public IEModule()
        {
            InitializeComponent();
            //Please write any initialization code in the OnConnect event handler
        }

        private ContextMenuStrip contextMenu;
        private ToolStripMenuItem customMenuItem;
        private ToolStripSeparator toolStripSeparator1;
        private ToolStripMenuItem propMenuItem;
 
        public IEModule(IContainer container)
        {
            container.Add(this);
 
            InitializeComponent();
            //Please write any initialization code in the OnConnect event handler
        }
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(IEModule));
            this.contextMenu = new System.Windows.Forms.ContextMenuStrip(this.components);
            this.customMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.toolStripSeparator1 = new System.Windows.Forms.ToolStripSeparator();
            this.propMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.contextMenu.SuspendLayout();
            // 
            // contextMenu
            // 
            this.contextMenu.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.customMenuItem,
            this.toolStripSeparator1,
            this.propMenuItem});
            this.contextMenu.Name = "contextMenu";
            this.contextMenu.Size = new System.Drawing.Size(173, 54);
            // 
            // customMenuItem
            // 
            this.customMenuItem.Image = ((System.Drawing.Image)(resources.GetObject("customMenuItem.Image")));
            this.customMenuItem.Name = "customMenuItem";
            this.customMenuItem.Size = new System.Drawing.Size(172, 22);
            this.customMenuItem.Text = "Show Outer HTML";
            this.customMenuItem.Click += new System.EventHandler(this.customMenuItem_Click);
            // 
            // toolStripSeparator1
            // 
            this.toolStripSeparator1.Name = "toolStripSeparator1";
            this.toolStripSeparator1.Size = new System.Drawing.Size(169, 6);
            // 
            // propMenuItem
            // 
            this.propMenuItem.Image = ((System.Drawing.Image)(resources.GetObject("propMenuItem.Image")));
            this.propMenuItem.Name = "propMenuItem";
            this.propMenuItem.Size = new System.Drawing.Size(172, 22);
            this.propMenuItem.Text = "Properties";
            this.propMenuItem.Click += new System.EventHandler(this.propMenuItem_Click);
            // 
            // IEModule
            // 
            this.HandleShortcuts = true;
            this.LoadInMainProcess = false;
            this.ModuleName = "CustomContextMenu";
            this.OnShowContextMenu += new AddinExpress.IE.ADXIEShowContextMenu_EventHandler(this.IEModule_OnShowContextMenu);
            this.contextMenu.ResumeLayout(false);

        }
        #endregion
 
        #region ADX automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void RegisterIEModule(Type t)
        {
            AddinExpress.IE.ADXIEModule.RegisterIEModuleInternal(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void UnregisterIEModule(Type t)
        {
            AddinExpress.IE.ADXIEModule.UnregisterIEModuleInternal(t);
        }
 
        [ComVisible(true)]
        public class IECustomContextMenuCommands :
            AddinExpress.IE.ADXIEModule.ADXIEContextMenuCommandDispatcher
        {
        }
 
        [ComVisible(true)]
        public class IECustomCommands :
            AddinExpress.IE.ADXIEModule.ADXIECommandDispatcher
        {
        }
 
        #endregion
 
        public IE.WebBrowser IEApp
        {
            get
            {
                return (this.IEObj as IE.WebBrowser);
            }
        }
 
        public mshtml.HTMLDocument HTMLDocument
        {
            get
            {
                return (this.HTMLDocumentObj as mshtml.HTMLDocument);
            }
        }

        private void IEModule_OnShowContextMenu(object sender, ADXIEShowContextMenuEventArgs e)
        {
            if (e.ContextMenu == ADXIEShowContextMenuEventArgs.ADXIEDocContextMenu.Anchor)
            {
                this.targetObj = e.Container as IOleCommandTarget;
                this.targetElem = e.HTMLElement as mshtml.IHTMLElement;
                e.Handled = true;

                contextMenu.Show(e.Location);
            }
        }

        private void customMenuItem_Click(object sender, EventArgs e)
        {
            if (this.targetElem != null)
                MessageBox.Show(this, this.targetElem.outerHTML, this.ModuleName, MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void propMenuItem_Click(object sender, EventArgs e)
        {   
            if (this.targetObj != null)
                this.targetObj.Exec(IntPtr.Zero, OLECMDID_PROPERTIES, OLECMDEXECOPT_DODEFAULT, IntPtr.Zero, IntPtr.Zero);
        }

        [StructLayout(LayoutKind.Sequential, Pack = 4)]
        internal struct OLECMD
        {
            public uint cmdID;
            public uint cmdf;
        }

        [ComImport, Guid("B722BCCB-4E68-101B-A2BC-00AA00404770"), InterfaceType(1)]
        internal interface IOleCommandTarget
        {
            [PreserveSig]
            int QueryStatus(IntPtr pguidCmdGroup, [In] uint cCmds, [In, Out, MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 1)] OLECMD[] prgCmds, [In, Out] IntPtr pCmdText);
            [PreserveSig]
            int Exec(IntPtr pCmdGroup, [In] uint nCmdID, [In] uint nCmdexecopt, [In] IntPtr pvaIn, [In] IntPtr pvaOut);
        }
    }
}

